#<profile4xi profile = "11" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "kpu2kernel4xi5test.py">
#<abstract4xi abstract = "tests kpu2kernel4xi.py"/>
#<verify4xi verification = "11" target = "kpu2kernel4xi.py"/>
#<contextualize4xi context = "kernel4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = "  
__all__ = ['kpu2kernel4xi5test'] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging  
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/> 

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from pipe4xi import Pipe4Xi   
from platformids4xi import get2platformids4xi
from queue4xi import Queue4Xi

# -------------------------------------------------------------------------------------------------
# Command queue module                           
# -------------------------------------------------------------------------------------------------
from kpu2commandqueue4xi import KPU2CommandQueue4Xi
from kpu2commandqueue4xi import create2commandqueue4kpu 
from kpu2commandqueue4xi import flush2commandqueue4kpu
from kpu2commandqueue4xi import finish2commandqueue4kpu
from kpu2commandqueue4xi import get2commandqueueinfo4kpu
from kpu2commandqueue4xi import release2commandqueue4kpu
from kpu2commandqueue4xi import retain2commandqueue4kpu
from kpu2commandqueue4xi import set2commandqueue4kpu
from kpu2commandqueue4xi import trace2commandqueue4kpu

# -------------------------------------------------------------------------------------------------
# Context module                           
# -------------------------------------------------------------------------------------------------
from kpu2context4xi import KPU2Context4Xi 
from kpu2context4xi import create2context4kpu
from kpu2context4xi import get2context4kpu
from kpu2context4xi import release2context4kpu
from kpu2context4xi import retain2context4kpu
from kpu2context4xi import set2context4kpu


# -------------------------------------------------------------------------------------------------
# Device module                        
# -------------------------------------------------------------------------------------------------
from kpu2device4xi import KPU4Xi
from kpu2device4xi import init2kpu4xi 
from kpu2device4xi import set2kpu4xi
from kpu2device4xi import get2kpu4xi


# -------------------------------------------------------------------------------------------------
# Event module                           
# -------------------------------------------------------------------------------------------------
from kpu2event4xi import KPU2Event4Xi
from kpu2event4xi import create2event4kpu
from kpu2event4xi import get2eventinfo4kpu
from kpu2event4xi import release2event4kpu
from kpu2event4xi import retain2event4kpu
from kpu2event4xi import set2eventcallback4kpu 
from kpu2event4xi import set2event4kpu
from kpu2event4xi import trace2event4kpu
from kpu2event4xi import wait2event4kpu

# -------------------------------------------------------------------------------------------------
# Image module                           
# -------------------------------------------------------------------------------------------------
from kpu2image4xi import KPU2Image4Xi
from kpu2image4xi import create2image4kpu
from kpu2image4xi import get2imageinfo4kpu
from kpu2image4xi import get2supportedimageformats4kpu
from kpu2image4xi import manoeuvre2copyimage4kpu
from kpu2image4xi import manoeuvre2copyimagetobuffer4kpu
from kpu2image4xi import manoeuvre2copybuffertoimage4kpu
from kpu2image4xi import manoeuvre2readimage4kpu
from kpu2image4xi import manoeuvre2writeimage4kpu
from kpu2image4xi import manoeuvre2mapimage4kpu
from kpu2image4xi import copy2image4kpu
from kpu2image4xi import copy2imagetobuffer4kpu
from kpu2image4xi import copy2buffertoimage4kpu
from kpu2image4xi import read2image4kpu
from kpu2image4xi import map2image4kpu
from kpu2image4xi import release2image4kpu
from kpu2image4xi import retain2image4kpu
from kpu2image4xi import set2imagecallback4kpu 
from kpu2image4xi import set2image4kpu
from kpu2image4xi import trace2image4kpu
from kpu2image4xi import wait2image4kpu
from kpu2image4xi import write2image4kpu

# -------------------------------------------------------------------------------------------------
# Kernel module                           
# -------------------------------------------------------------------------------------------------
from kpu2kernel4xi import KPU2Kernel4Xi
from kpu2kernel4xi import add2kernel4kpu
from kpu2kernel4xi import execute2kernel4kpu
from kpu2kernel4xi import execute2task4kpu
from kpu2kernel4xi import execute2nativekernel4kpu
from kpu2kernel4xi import create2kernel4kpu
from kpu2kernel4xi import create2kernelsinprogram4kpu
from kpu2kernel4xi import delete2kernel4kpu
from kpu2kernel4xi import get2kernelinfo4kpu
from kpu2kernel4xi import get2kernelworkgroupinfo4kpu
from kpu2kernel4xi import get2kernelarginfo4kpu
from kpu2kernel4xi import release2kernel4kpu
from kpu2kernel4xi import retain2kernel4kpu
from kpu2kernel4xi import set2kernel4kpu
from kpu2kernel4xi import set2kernelcallback4kpu 
from kpu2kernel4xi import set2kernelarg4kpu
from kpu2kernel4xi import trace2kernel4kpu

# -------------------------------------------------------------------------------------------------
# Program module                           
# -------------------------------------------------------------------------------------------------
from kpu2program4xi import KPU2Program4Xi
from kpu2program4xi import add2programwithsource4kpu
from kpu2program4xi import add2programwithbinary4kpu
from kpu2program4xi import build2program4kpu
from kpu2program4xi import compile2program4kpu
from kpu2program4xi import create2programwithsource4kpu
from kpu2program4xi import create2programwithbinary4kpu
from kpu2program4xi import delete2programwithsource4kpu
from kpu2program4xi import delete2programwithbinary4kpu
from kpu2program4xi import get2programinfo4kpu
# from kpu2program4xi import get2programbuildinfo4kpu
from kpu2program4xi import link2program4kpu
from kpu2program4xi import release2program4kpu
from kpu2program4xi import retain2program4kpu
from kpu2program4xi import set2programcallback4kpu 
from kpu2program4xi import set2programwithsource4kpu
from kpu2program4xi import set2programwithbinary4kpu
from kpu2program4xi import trace2program4kpu
# from kpu2program4xi import unload2compiler4kpu


# -------------------------------------------------------------------------------------------------
# Platform module                           
# -------------------------------------------------------------------------------------------------
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi

# -------------------------------------------------------------------------------------------------
# Trace modules                    
# -------------------------------------------------------------------------------------------------

                                                                                                                  # REMEMBER TO MODIFY NECESSARY MODULES BEFORE TESTS !!
                                                                                                                  
from print4xi import Print4Xi                                                                                     # edit print4xi.py - embeds trace for the functions and classes to be tested
from print4xi import print4xi                                                                                     # see OpenCl4Xi definitions in print4xi.py

from pickle4xi import pickle4xi                                                                                   # edit corresponding pickle2?4xi.py
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 

    
from actor2a4xi import Actor2a4Xi                                                                                   # define functions and class for zapping 
from actor2b4xi import Actor2b4Xi                                                                                   # not necessary for testing but got to be done later on!
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi
from time4xi import time4xi                                                                                         # time stamp to events

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   # XML trace
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>


# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global folder2lib4kpu                                                   # Folder of KPU library
global kb2fetch4kpu                                                     # Knowledgebase for fetching
global KB4Focus                                                         # Focus knowledgebase
global profile2fetch4source                                             # Extension for source files
global profile2fetch4binary                                             # Extension for binary files

global PickleKB4Xi
global t2xi                                                             # Print4Xi object for trace
    
# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
temp2kpu = 'kpu'
key2dir = temp2kpu[0]                                    # MORE COMPLIATED WAY DUE TO AUTOMATIC SOFTWARE GENERATION
folder2lib4kpu = VersionKB4Xi[key2dir] 

KB4Focus = {                                             #  NACK= Focus; (01) = first focus (02) = second focus etc                                      
         'add2kernel4kpu':                   'ACK4XI',   # (FOCUS 04)         

         'execute2kernel4kpu':               'ACK4XI',   # (FOCUS 20)                  
         'execute2task4kpu':                 'ACK4XI',   # (FOCUS 19)
         'execute2nativekernel4kpu':         'ACK4XI',   # (FOCUS 02)
         
         'create2kernel4kpu':                'NACK4XI',   # (FOCUS 01) - CREATE FUNCTION IS REQUIRED TO TEST SOME OTHER FUNCTIONS!
         'create2kernelsinprogram4kpu':      'ACK4XI',   # (FOCUS 21)
         
         'delete2kernel4kpu':                'ACK4XI',   # (FOCUS 05, 09)              
         
         'get2kernelinfo4kpu':               'ACK4XI',   # (FOCUS 06,10,11) needed by other 
         'get2kernelworkgroupinfo4kpu':      'ACK4XI',   # (FOCUS 03)         
         
         'release2kernel4kpu':               'ACK4XI',   # (FOCUS 15)
         'retain2kernel4kpu':                'ACK4XI',   # (FOCUS 16)         
         
         'set2kernelcallback4kpu':           'ACK4XI',   # (FOCUS 17)
         'set2kernel4kpu':                   'ACK4XI',   # (FOCUS 12)
         'set2kernelarg4kpu':                'ACK4XI',   # (FOCUS 14)     
         
         'trace2kernel4kpu':                 'ACK4XI',   # (FOCUS 18)
         
        
         'KPU2Kernel4Xi':                    'ACK4XI',  # (FOCUS 110) - CLASS  - MANDATORY TO HAVE ANY METHOD IN FOCUS - __INIT__ calls create2kernelswithsource !
         'add2kernel':                       'ACK4XI',   # (FOCUS 122, FOCUS 132)         
         'execute2task':                     'ACK4XI',   # (FOCUS 240)
         'execute2nativekernel':             'ACK4XI',   # ()
         'create2kernel':                    'ACK4XI',  # (FOCUS 115,FOCUS 190)
         'create2kernelsinprogram':          'ACK4XI',   # ()
         'delete2kernel':                    'ACK4XI',   # (FOCUS 124,FOCUS 134)              
         'get2kernelinfo':                   'ACK4XI',   # (FOCUS 140 
         'set2kernelarg':                    'ACK4XI',   # (FOCUS 150)
         'get2kernelworkgroupinfo':          'ACK4XI',   # (FOCUS 121C)         
         'release2kernel':                   'ACK4XI',   # (FOCUS 170,FOCUS 220)
         'retain2kernel':                    'ACK4XI',   # (FOCUS 180,FOCUS 230)         
         'set2kernelcallback':               'ACK4XI',   # (FOCUS 200)
         'set2kernel':                       'ACK4XI',   # ()
         'set2kernelarg':                    'ACK4XI',   # ()     
         'trace2kernel':                     'ACK4XI',   # (FOCUS 210)
         'execute2kernel':                   'ACK4XI',   # (FOCUS 121A)
         'sense':                            'ACK4XI',   # (FOCUS 310)
         'reason':                           'ACK4XI',   # (FOCUS 320)
         'ace':                              'ACK4XI'    # (FOCUS 330)                                      
        }                                                               # TIP: SEARCH WITH FOCUS NN IN TEST OUT FILE, WHERE NN = 01,02 ...                    

profile2fetch4source = '.py'                                            # Example extensions: '.txt'= text '.py'=Python, '.cpp'=C++, '.hpp'=headers, '.c'=C
profile2fetch4binary = '.pyc'                                           #  

kb2fetch4kpu = {}                                                       # Programs to be fetched                                
kb2fetch4kpu[1] = 'kpu2sampler4xi5test.py'                           # source
kb2fetch4kpu[2] = 'kpu2sampler4xi5test.cpython-33.pyc'               # binary

# kb2fetch4kpu[3]  = 'kpu2image4xi5test.py'
# kb2fetch4kpu[4]  = 'kpu2image4xi5test.cpython-33.pyc'
# kb2fetch4kpu[5]  = 'kpu3image4xi5test.py'
# kb2fetch4kpu[6]  = 'kpu3image4xi5test.cpython-33.pyc'
# kb2fetch4kpu[7]  = 'kpu2commandqueue4xi5test.py'
# kb2fetch4kpu[8]  = 'kpu2commandqueue4xi5test.cpython-33.pyc'
# kb2fetch4kpu[9]  = 'kpu2event4xi5test.py'
# kb2fetch4kpu[10] = 'kpu2event4xi5test.cpython-33.pyc'
# kb2fetch4kpu[11] = 'kpu2program4xi5test.py'
# kb2fetch4kpu[12] = 'kpu2program5test.cpython-33.pyc'
# kb2fetch4kpu[13] = 'kpu2kernel4xi5test.py'
# kb2fetch4kpu[14] = 'kpu2kernel5test.cpython-33.pyc'

PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         'KPU2Kernel4Xi':                    'NACK4XI',  # class     - all methods will be traced
         
         'add2kernel4kpu':                   'NACK4XI',
         
         'execute2kernel4kpu':               'NACK4XI',          
         'execute2task4kpu':                 'NACK4XI',
         'execute2nativekernel4kpu':         'NACK4XI',  
         
         'create2kernel4kpu':                'NACK4XI',  
         'create2kernelsinprogram4kpu':      'NACK4XI', 
         
         'delete2kernel4kpu':                'NACK4XI',             
         
         'fetch2kernel4kpu':                 'NACK4XI',
    
         'get2kernelinfo4kpu':               'NACK4XI',
         'set2kernelarg4kpu':                'NACK4XI',
         'get2kernelworkgroupinfo4kpu':      'NACK4XI',
         
         'release2kernel4kpu':               'NACK4XI',
         'retain2kernel4kpu':                'NACK4XI',         
         
         'set2kernelcallback4kpu':           'NACK4XI',
         'set2kernel4kpu':                   'NACK4XI',
         'set2kernelarg4kpu':                'NACK4XI',          
         
         'trace2kernel4kpu':                 'NACK4XI',
         'create2sampler4kpu':               'NACK4XI'   # activated target function trace! 
        }                              
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>             


    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
#   print XML trace for program4kpu test
#"> 

# -------------------------------------------------------------------------------------------------    
def print2trace4xi(t2xi):

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\sense-kpu2kernel4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourkpuxi.org/sw4xi/python33/owl/multiprocessing4kpu.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourkpuxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Kernel of KPU.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Kernel of KPU sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\reason-kpu2kernel4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourkpuxi.org/sw4xi/python33/owl/multiprocessing4kpu.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourkpuxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Kernel of KPU.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\ace-kpu2kernel4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourkpuxi.org/sw4xi/python33/owl/multiprocessing4kpu.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourkpuxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Kernel of KPU.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of Kernel of KPU.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print2trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "kpu2kernel4xi5test" usage = "
#   tests program4kpu
#"> 

# -------------------------------------------------------------------------------------------------    
def kpu2kernel4xi5test():
    global KB4Focus
    global folder2lib4kpu

    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 0A/33) OF TEST_RESOURCESHARER4XI - SET T2XI TO: ", t2xi)
    # 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:

        # ---------------------------------------------------------------------------------------------
        # START TESTING                          
        # ---------------------------------------------------------------------------------------------    
        print('(Step 1A/700) OF KPU2KERNEL4XI5TEST - STARTED ', time4xi()) 

        # =============================================================================================
        # FUNCTION TESTS
        # =============================================================================================          
        print('JATKA') 
        print('FOCUS 01')
        if KB4Focus['create2kernel4kpu'] == 'NACK4XI':              
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - CREATE KERNEL USING FUNCTION WITHOUT PARAMETERS                          
            # ---------------------------------------------------------------------------------------------    
            print('(Step 2A0/700) OF KPU2KERNEL4XI5TEST - TRYING TO CREATE KERNEL FOR KPU WITHOUT PARAMETERS USING FUNCTION ', time4xi())        
            try:
                response4create2kernel = create2kernel4kpu()
                print('(Step 2B0/700) OF KPU2KERNEL4XI5TEST - CREATED KERNEL FOR KPU WITHOUT PARAMETERS USING FUNCTION ', time4xi())
            except:
                print('(Step 2Z0/700) OF KPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL FOR KPU WITHOUT PARAMETERS USING FUNCTION ', time4xi())
            try:                                                                                      
                keys2kernel4kpu = response4create2kernel.keys()
                for key2kernel4kpu in keys2kernel4kpu:
                    print('KEY2KERNEL4KPU ', key2kernel4kpu)
                    # DIRECTORY4CL
                    # CODE4PY
                    # COUNT4CPP
                    # DIRECTORY4PYC
                    # QUEUE
                    # PROGRAM
                    # CONTEXT
                    # DIRECTORY4PY
                    # DIRECTORY4C
                    # PIPE
                    # SIZE4PY
                    # COUNT4PYC
                    # CODE4C
                    # DIRECTORY4BIN
                    # FUNCTION2CALLBACK
                    # CODE4CL
                    # COMMANDQUEUE
                    # PLATFORM
                    # COUNT4C
                    # FUNCTION
                    # CODE2ERROR
                    # ACK2RETURN
                    # DATA2CALLBACK
                    # BUFFER
                    # CODE4PYC
                    # CODE4CPP
                    # COUNT4CL
                    # COUNT2REFERENCE
                    # DEVICE
                    # SIZE4CPP
                    # LANGUAGE
                    # SIZE4PYC
                    # DIRECTORY4CPP
                    # SIZE4BIN
                    # COUNT4PY
                    # NACK2RETURN
                    # COUNT4BIN
                    # CODE4BIN
                    # EVENT
            except:
                print('(Step 2Z1/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:                                                                                      
                print('FUNCTION2KERNEL4KPU: ' , response4create2kernel['FUNCTION'])
                # {'.py': {'kpu2sampler4xi5test': {}}, '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}}
            except:
                print('(Step 2Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                keys2CODE4PY = response4create2kernel['CODE4PY'].keys()                                                                                      
                print('CODE4PY: ' , keys2CODE4PY)
                # ['folder2lib4kpu + kpu2sampler4xi5test.py']
            except:
                print('(Step 2Z4/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                print('DIRECTORY4PYC: ' , response4create2kernel['DIRECTORY4PYC'])
                # folder2lib4kpu + __pycache__//
            except:
                print('(Step 2Z5/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                print('DIRECTORY4PY: ' , response4create2kernel['DIRECTORY4PY'])
                # folder2lib4kpu 
            except:
                print('(Step 2Z6/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                print('DIRECTORY4CPP: ' , response4create2kernel['DIRECTORY4CPP'])
                # folder2lib4kpu
            except:
                print('(Step 2Z7/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel) 
            
            try:
                keys2CODE4CPP = response4create2kernel['CODE4CPP'].keys()                                                                                      
                print('CODE4CPP: ' , keys2CODE4CPP)
                # ['folder2lib4kpu + kpu2dummy4xi5test.cpp']
            except:
                print('(Step 2Z8/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                keys2CODE4BIN = response4create2kernel['CODE4BIN'].keys()                                                                                      
                print('CODE4BIN: ' , keys2CODE4BIN)
                # ['folder2lib4kpu + bin//kpu2dummy4xi5test.exe'] 
            except:
                print('(Step 2Z9/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                keys2CODE4PYC = response4create2kernel['CODE4PYC'].keys()                                                                                      
                print('CODE4PYC: ' , keys2CODE4PYC)
                # ['folder2lib4kpu + __pycache__//kpu2sampler4xi.cpython-33.pyc'] 
            except:
                print('(Step 2Z10/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                keys2SIZE4CPP = response4create2kernel['SIZE4CPP'].keys()                                                                                      
                print('SIZE4CPP: ' , keys2SIZE4CPP)
                # ['folder2lib4kpu + kpu2dummy4xi5test.cpp']
            except:
                print('(Step 2Z11/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)                                   
            
            try:
                keys2SIZE4PYC = response4create2kernel['SIZE4PYC'].keys()                                                                                      
                print('SIZE4PYC: ' , keys2SIZE4PYC)
                # ['folder2lib4kpu + __pycache__//kpu2sampler4xi.cpython-33.pyc']
            except:
                print('(Step 2Z12/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                keys2SIZE4BIN = response4create2kernel['SIZE4BIN'].keys()                                                                                      
                print('SIZE4BIN: ' , keys2SIZE4BIN)
                # ['folder2lib4kpu + bin//kpu2dummy4xi5test.exe'] 
            except:
                print('(Step 2Z13/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)                                                 
            
            try:
                print('COUNT4PY: ' , response4create2kernel['COUNT4PY'])
                # 1
            except:
                print('(Step 2Z14/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                print('COUNT4BIN: ' , response4create2kernel['COUNT4BIN'])
                # 1 
            except:
                print('(Step 2Z15/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                print('COUNT4CPP: ' , response4create2kernel['COUNT4CPP'])
                # 1 
            except:
                print('(Step 2Z16/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                keys2SIZE4PY = response4create2kernel['SIZE4PY'].keys()                                                                                      
                print('SIZE4PY: ' , keys2SIZE4PY)
                # ['folder2lib4kpu + kpu2sampler4xi5test.py']
            except:
                print('(Step 2Z17/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)                                                 
            
            try:
                print('COUNT4PYC: ' , response4create2kernel['COUNT4PYC'])
                # 1
            except:
                print('(Step 2Z18/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            
            try:
                print('DIRECTORY4BIN: ' , response4create2kernel['DIRECTORY4BIN'])
                # folder2lib4kpu + bin// 
            except:
                print('(Step 2Z19/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)                                                                             
         
        print('FOCUS 01')
        if KB4Focus['create2kernel4kpu'] == 'NACK4XI':              
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - CREATE KERNEL USING FUNCTION WITH PARAMETERS                          
            # ---------------------------------------------------------------------------------------------    
            print('(Step 2A1/700) OF KPU2KERNEL4XI5TEST - TRYING TO CREATE KERNEL FOR KPU WITH PARAMETERS USING FUNCTION ', time4xi())       
            try:
                task4kernel2kpu = {}
                task4kernel2kpu ['PROGRAM']  = create2programwithsource4kpu()
                task4kernel2kpu ['FUNCTION'] = "kpu2sampler4xi5test"
                
                response4create2kernel = create2kernel4kpu(task4kernel2kpu)
                
                print('(Step 2B1/700) OF KPU2KERNEL4XI5TEST - CREATED KERNEL FOR KPU WITH PARAMETERS USING FUNCTION ', task4kernel2kpu)
                # {'FUNCTION': 'kpu2sampler4xi5test', 'PROGRAM': ...
                
            except:
                print('(Step 2Z4/700) OF KPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL FOR KPU WITH PARAMETERS USING FUNCTION ', time4xi())
            try:                                                                                      
                keys2kernel4kpu = response4create2kernel.keys()
                for key2kernel4kpu in keys2kernel4kpu:
                    print('KEY2KERNEL4KPU ', key2kernel4kpu)
                    # FUNCTION
                    # PIPE
                    # DIRECTORY4CL
                    # COUNT2REFERENCE
                    # LANGUAGE
                    # DATA2CALLBACK
                    # DIRECTORY4BIN
                    # FUNCTION2CALLBACK
                    # DIRECTORY4CPP
                    # DIRECTORY4PYC
                    # QUEUE
                    # PROGRAM
                    # NACK2RETURN
                    # DIRECTORY4PY
                    # ACK2RETURN
                    # DIRECTORY4C
                    
            except:
                print('(Step 2Z5/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel)
            try:                                                                                      
                print('FUNCTION2KERNEL4KPU: ' , response4create2kernel['FUNCTION'])
                # kpu2sampler4xi5test
                    
            except:
                print('(Step 2Z6/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel ', response4create2kernel) 
                                                       
        print('FOCUS 02')  
        if KB4Focus['execute2nativekernel4kpu'] == 'NACK4XI':
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - EXECUTE KERNEL OF KPU WITH FUNCTION                         
            # ---------------------------------------------------------------------------------------------    
            print('(Step 2A2/700) OF KPU2KERNEL4XI5TEST - TRYING TO EXECUTE KERNEL OF KPU WITH FUNCTION  ', time4xi())           
            try:
                response4execute2kernel = execute2nativekernel4kpu()
                print('(Step 2B2/700) OF KPU2KERNEL4XI5TEST - EXECUTED KERNEL OF KPU WITH FUNCTION  ', time4xi()) 
            except:
                print('(Step 2Z1/700) OF KPU2KERNEL4XI5TEST *** FAILED TO EXECUTE KERNEL OF KPU WITH FUNCTION ', time4xi())                                                                      
            try:
                keys2response4execute= response4execute2kernel.keys()
                for key2response4execute in keys2response4execute:
                    print('KEY2RESPONSE4EXECUTE: ', key2response4execute)
                    #         
            except:
                print('(Step 2Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4execute2kernel *** ', response4execute2kernel)
                
            tailor2trace4kernel(t2xi) # TAILOR TRACE AGAIN - TARGET FUNCTIONS OF ACTIVATED PROCESSES MIGHT HAVE RESET TRACE !    


        print('FOCUS 03')                       
        if KB4Focus['get2kernelworkgroupinfo4kpu'] == 'NACK4XI':        
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - GET KERNEL WORKGROUP INFO OF KPU                         
            # ---------------------------------------------------------------------------------------------    
            print('(Step 2AB2/700) OF KPU2KERNEL4XI5TEST - TRYING TO GET KERNEL WORKGROUP INFO OF KPU FUNCTION ', time4xi())           
            try:
                response4get2workgroupinfo = get2kernelworkgroupinfo4kpu()
                print('(Step 2BB2/700) OF KPU2KERNEL4XI5TEST - GOT KERNEL WORKGROUP INFO OF KPU FUNCTION ', time4xi()) 
            except:
                print('(Step 2Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL WORKGROUP INFO OF KPU FUNCTION ', time4xi())                                                                     
            try:
                print('(Step CC2/700) OF KPU2KERNEL4XI5TEST - response4get2workgroupinfo:') 
                keys2response = response4get2workgroupinfo.keys()
                for key2response in sorted(keys2response):
                    print(key2response, ' : ', response4get2workgroupinfo[key2response])
                    # 
            except:
                print('(Step 2Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4get2workgroupinfo *** ', response4get2workgroupinfo)
                
            tailor2trace4kernel(t2xi)  # TAILOR TRACE AGAIN - TARGET FUNCTIONS OF ACTIVATED PROCESSES MIGHT HAVE RESET TRACE !    

         
         
        print('FOCUS 04')               
        if KB4Focus['add2kernel4kpu'] == 'NACK4XI':                 
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - ADD KERNEL INTO KERNEL OBJECT WITH FUNCTION                          
            # ---------------------------------------------------------------------------------------------    
            print('(Step 2A3/700) OF KPU2KERNEL4XI5TEST - TRYING TO ADD KERNEL INTO KERNEL OBJECT WITH FUNCTION ', time4xi())          
            try:
                task4add2kernel = {}
                task4add2kernel ['CODE4KERNEL'] = {}
                task4add2kernel ['CODE4KERNEL'] [folder2lib4kpu + 'kpu2dummy4xi.py'] = {}
                task4add2kernel ['CODE4KERNEL'] [folder2lib4kpu + 'kpu2dummy4xi.py'] [1] = '#<profile4xi profile = "33" />\n'
                task4add2kernel ['CODE4KERNEL'] [folder2lib4kpu + 'kpu2dummy4xi.py'] [2] = '#<program4xi program = "kpu2dummy4xi.py" />\n'
                task4add2kernel ['SIZE4SOURCE'] = {}
                task4add2kernel ['SIZE4SOURCE'] [folder2lib4kpu + 'kpu2dummy4xi.py'] = len(task4add2kernel ['CODE4KERNEL'] [folder2lib4kpu + 'kpu2dummy4xi.py'])
                        
                response4add2kernel = add2kernel4kpu(task4add2kernel)
                print('(Step 2A4/700) OF KPU2KERNEL4XI5TEST - ADDED KERNEL INTO KERNEL OBJECT WITH FUNCTION ', time4xi())
                #                                                                                   
            except:
                print('(Step 2Z3/700) OF KPU2KERNEL4XI5TEST *** FAILED TO ADD KERNEL INTO KERNEL OBJECT WITH FUNCTION ', time4xi())
            try:                                                                                      
                keys2kernel = response4add2kernel.keys()
                for key2kernel in keys2kernel:
                    print('KEY2KERNEL ' , key2kernel)
                    #        
            except:
                print('(Step 2Z4/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4add2kernel *** ', response4add2kernel)                

        
        print('FOCUS 05')             
        if KB4Focus['delete2kernel4kpu'] == 'NACK4XI':       
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - DELETE KERNEL INSIDE KERNEL OBJECT WITH FUNCTION                          
            # ---------------------------------------------------------------------------------------------    
            print('(Step 2A4/700) OF KPU2KERNEL4XI5TEST - TRYING TO DELETE KERNEL INSIDE KERNEL OBJECT WITH FUNCTION  ', time4xi())        
            try:
                task4delete2kernel = {}
                task4delete2kernel ['CODE4SOURCE'] = {}
                task4delete2kernel ['CODE4SOURCE'] [folder2lib4kpu + 'kpu2dummy4xi.py'] = 'Yes'
    
                task4delete2kernel ['SIZE4SOURCE'] = {}
                task4delete2kernel ['SIZE4SOURCE'] [folder2lib4kpu + 'kpu2dummy4xi.py'] = 'Yes'
                
                response4delete2kernel = delete2kernel4kpu(task4delete2kernel)
                print('(Step 2A5/700) OF KPU2KERNEL4XI5TEST - DELETED DELETE KERNEL INSIDE KERNEL OBJECT WITH FUNCTION  ', time4xi())
            except:
                print('(Step 2Z4/700) OF KPU2KERNEL4XI5TEST *** FAILED TO DELETE KERNEL INSIDE KERNEL OBJECT WITH FUNCTION  ', time4xi()) 
            try:                                                                                      
                keys2kernel = response4delete2kernel.keys()
                for key2kernel in keys2kernel:
                     print('KEY2KERNEL ',  key2kernel)
                    #    
            except:
                print('(Step 2Z5/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4delete2kernel *** ', response4delete2kernel)                         
        
        print('FOCUS 06')            
        if KB4Focus['get2kernelinfo4kpu'] == 'NACK4XI': 
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - GET SOME KERNEL INFO WITH FUNCTION                
            # ---------------------------------------------------------------------------------------------    
            print('(Step 2B1/700) OF KPU2KERNEL4XI5TEST - TRYING TO GET SOME KERNEL INFO FOR KPU ', time4xi())     
            try:
                response4programinfo2kpu = get2kernelinfo4kpu()
                print('(Step 2B2/700) OF KPU2KERNEL4XI5TEST - GOT SOME KERNEL INFO FOR KPU ', time4xi())  
            except:
                print('(Step 2Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO GET SOME KERNEL INFO FOR KPU', time4xi())
            try:                                                                                          
                for key2kernel in keys2kernel:
                    print('KEY2KERNEL ', key2kernel)
                    #                 
            except:
                print('(Step 2Z3/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4programinfo2kpu: ', response4programinfo2kpu)

        print('FOCUS 06')               
        if KB4Focus['get2kernelinfo4kpu'] == 'NACK4XI': 
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - GET ALL KERNEL INFO WITH FUNCTION                
            # ---------------------------------------------------------------------------------------------           
            print('(Step 2C1/700) OF KPU2KERNEL4XI5TEST - TRYING TO GET ALL KERNEL INFO FOR KPU ', time4xi())      
            try:
                response4getinfo2kernel = get2kernelinfo4kpu()
                print('(Step 2C2/700) OF KPU2KERNEL4XI5TEST - GOT ALL KERNEL INFO FOR KPU ', time4xi())
            except:
                print('(Step 2Z3/700) OF KPU2KERNEL4XI5TEST *** FAILED TO GET ALL KERNEL INFO FOR KPU ', time4xi())
            try:                                                                                          
                keys2response = response4getinfo2kernel.keys()
                for key2response in sorted(keys2response):
                    print(key2response)
                    # 
            except:
                print('(Step 2Z4/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4getinfo2kernel: ', response4getinfo2kernel)

              


        print('FOCUS 09')            
        if KB4Focus['delete2kernel4kpu'] == 'NACK4XI':      
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - DELETE KERNEL INSIDE KERNEL OBJECT WITH FUNCTION                          
            # ---------------------------------------------------------------------------------------------    
            print('(Step 3A3/700) OF KPU2KERNEL4XI5TEST - TRYING TO DELETE KERNEL INSIDE KERNEL OBJECT WITH FUNCTION ', time4xi())        
            try:
                task4delete2kernel = {}
                task4delete2kernel ['CODE4KERNEL'] = {}
                task4delete2kernel ['CODE4KERNEL'] [folder2lib4kpu + 'dummy2kernel4xi.py'] = 'Yes'
    
                task4delete2kernel ['SIZE4KERNEL'] = {}
                task4delete2kernel ['SIZE4KERNEL'] [folder2lib4kpu + 'dummy2kernel4xi.py'] = 'Yes'
                
                response4delete2kernel = delete2kernel4kpu(task4delete2kernel) 
                print('(Step 3A3/700) OF KPU2KERNEL4XI5TEST - DELETED KERNEL INSIDE KERNEL OBJECT WITH FUNCTION ', time4xi())
            except:
                print('(Step 3Z3/700) OF KPU2KERNEL4XI5TEST *** FAILED TO DELETE KERNEL INSIDE KERNEL OBJECT WITH FUNCTION *** ', time4xi()) 
            try:                                                                                          
                keys2kernel = response4delete2kernel['CODE4KERNEL'].keys()
                for key2kernel in keys2kernel:
                    print('key2kernel ', key2kernel)
                
            except:
                print('(Step 3Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4delete2kernel : ', response4delete2kernel)         
        
        
        print('FOCUS 10')           
        if KB4Focus['get2kernelinfo4kpu'] == 'NACK4XI':                  
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - GET SOME KERNEL INFO WITH FUNCTION                
            # ---------------------------------------------------------------------------------------------    
            print('(Step 3B1/700) OF KPU2KERNEL4XI5TEST - TRYING TO GET SOME KERNEL INFO FOR KPU ', time4xi())     
            task4getinfo2program = {}

            try:
                response4programinfo2kpu = get2kernelinfo4kpu() 
                print('(Step 3B2/700) OF KPU2KERNEL4XI5TEST - GOT SOME KERNEL INFO FOR KPU ', time4xi())
            except:
                print('(Step 3Z3/700) OF KPU2KERNEL4XI5TEST *** FAILED TO GET SOME KERNEL INFO FOR KPU', time4xi())                  
            try:                                                                                          
                keys2kernel = response4programinfo2kpu.keys()
                for key2kernel in keys2kernel:
                    print('KEY2KERNEL ', key2kernel)
                    #                  
            except:
                print('(Step 3Z4/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4programinfo2kpu : ', response4programinfo2kpu)


        
        print('FOCUS 12')           
        if KB4Focus['set2kernel4kpu'] == 'NACK4XI':                     
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - SET KERNEL WITH FUNCTION - ALL ATTRIBUTES                          
            # ---------------------------------------------------------------------------------------------    
            print('(Step 4A/700) OF KPU2KERNEL4XI5TEST - TRYING TO SET KERNEL WITH FUNCTION ', time4xi())    

            # ---------------------------------------------------------------------------------------------
            # (1) GET PLATFORM IDs TO SET CONTEXT
            # ---------------------------------------------------------------------------------------------    
            print('(Step 4B/700) OF KPU2KERNEL4XI5TEST - TRYING TO GET PLATFORMIDS4XI', time4xi())
            platform2xi = {}
            try:
                platform2xi = get2platformids4xi()
                print('(Step 4B/33) OF KPU2KERNEL4XI5TEST - GOT PLATFORMIDS4XI', platform2xi) 
                # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1} 
                 
            except:
                print('(Step 4Z/33) OF KPU2KERNEL4XI5TEST *** FAILED TO GET PLATFORMIDS4XI', time4xi())     
        
            # ---------------------------------------------------------------------------------------------
            # (2) INITIALIZE DEVICE                       
            # ---------------------------------------------------------------------------------------------    
            print('(Step 2A/33) OF KPU2KERNEL4XI5TEST - TRYING TO INITIALIZE DEVICE4KPU ', time4xi())   
            try:
                device2kpu = init2kpu4xi()                                                                                
                print('(Step 2B/33) OF KPU2KERNEL4XI5TEST - INITIALIZED DEVICE4KPU TO: ', device2kpu)        
                # {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
                
            except:
                print('(Step 2Z/33) OF KPU2KERNEL4XI5TEST *** FAILED TO INITIALIZE DEVICE4KPU', time4xi()) 
                    
                
            # ---------------------------------------------------------------------------------------------
            # (3) CREATE CONTEXT                  
            # ---------------------------------------------------------------------------------------------    
            print('(Step 3A/700) OF KPU2KERNEL4XI5TEST - TRYING TO CREATE CONTEXT4KPU ', time4xi())    
            try:
                context2kpu = create2context4kpu()                                                                            
                print('(Step 3B/700) OF KPU2KERNEL4XI5TEST - CREATED CONTEXT4KPU: ', context2kpu)                                  
                # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                
            except:
                print('(Step 3Z/700) OF KPU2KERNEL4XI5TEST *** FAILED TO CREATE CONTEXT4KPU', time4xi()) 
             
        
                  
            # ---------------------------------------------------------------------------------------------
            # (4) INITIALIZE TASK DICTIONARY                         
            # ---------------------------------------------------------------------------------------------            
            task4set2kernelws = {}
        
            
            # ---------------------------------------------------------------------------------------------
            # (5) DEFINE CONTEXT - REQUIRED                           
            # ---------------------------------------------------------------------------------------------         
            task4set2kernelws  ['CONTEXT'] = context2kpu  
         
            
            # ---------------------------------------------------------------------------------------------
            # (6) DEFINE DEVICE - EXTRA                          
            # ---------------------------------------------------------------------------------------------         
            task4set2kernelws  ['DEVICE'] = device2kpu  
        
    
            # ---------------------------------------------------------------------------------------------
            # (8) DEFINE ERROR CODE - REQUIRED                            
            # ---------------------------------------------------------------------------------------------         
            task4set2kernelws  ['CODE2ERROR'] = 0 
        
            
            # ---------------------------------------------------------------------------------------------
            # (9) SET QUEUE - EXTRA                            
            # ---------------------------------------------------------------------------------------------         
            task4set2kernelws ['QUEUE'] = None
            print('(Step 9A/700) OF KPU2KERNEL4XI5TEST - TRYING TO SET QUEUE FOR KERNEL4KPU ', time4xi())   
            try:                               
                task4set2kernelws ['QUEUE'] = Queue4Xi()                                                                                                                    
                print('(Step 9B/700) OF KPU2KERNEL4XI5TEST - QUEUE OF KERNEL4KPU: ', task4set2kernelws ['QUEUE'])                           
                # 
                
            except:
                print('(Step 9Z/700) OF KPU2KERNEL4XI5TEST *** FAILED TO SET QUEUE FOR KERNEL4KPU ', time4xi())  
                         
            
                    
            # ---------------------------------------------------------------------------------------------
            # (11) SET COUNT4SOURCE              
            # ---------------------------------------------------------------------------------------------         
            print('(Step 11A/700) OF KPU2KERNEL4XI5TEST - TRYING TO SET COUNT4SOURCE FOR KERNEL4KPU ', time4xi())    
            try:                               
                task4set2kernelws ['COUNT4SOURCE'] = int(len(kb2fetch4kpu)/2)                                                                                                               
                print('(Step 11B/700) OF KPU2KERNEL4XI5TEST - COUNT4SOURCE OF KERNEL4KPU: ', task4set2kernelws ['COUNT4SOURCE'])                           
                # 1
                
            except:
                print('(Step 11Z/700) OF KPU2KERNEL4XI5TEST *** FAILED TO SET COUNT4SOURCE FOR KERNEL4KPU ', time4xi())  
                
            
            # ---------------------------------------------------------------------------------------------
            # (12) SET DIRECTORY4SOURCE                       
            # ---------------------------------------------------------------------------------------------         
            print('(Step 12A/700) OF KPU2KERNEL4XI5TEST - TRYING TO SET DIRECTORY4SOURCE FOR KERNEL4KPU ', time4xi())    
            try: 
                     
                task4set2kernelws ['DIRECTORY4SOURCE'] = folder2lib4kpu                                                                                                          
                print('(Step 12B/700) OF KPU2KERNEL4XI5TEST - DIRECTORY4SOURCE OF KERNEL4KPU: ', task4set2kernelws ['DIRECTORY4SOURCE'])                            
                # folder2lib4kpu
                
            except:
                print('(Step 12Z/700) OF KPU2KERNEL4XI5TEST *** FAILED TO SET DIRECTORY4SOURCE FOR KERNEL4KPU ', time4xi())  
                    
            
            # ---------------------------------------------------------------------------------------------
            # (14) SET LANGUAGE4SOURCE                       
            # ---------------------------------------------------------------------------------------------         
            task4set2kernelws ['LANGUAGE4SOURCE'] = None
            print('(Step 14A/700) OF KPU2KERNEL4XI5TEST - TRYING TO SET LANGUAGE4SOURCE FOR KERNEL4KPU ', time4xi())    
            try:                               
                task4set2kernelws ['LANGUAGE4SOURCE'] = "Python"                                                                                                                   
                print('(Step 14B/700) OF KPU2KERNEL4XI5TEST - LANGUAGE4SOURCE OF KERNEL4KPU: ', task4set2kernelws ['LANGUAGE4SOURCE'])                           
                # Python
                
            except:
                print('(Step 14Z/700) OF KPU2KERNEL4XI5TEST *** FAILED TO SET LANGUAGE4SOURCE FOR KERNEL4KPU ', time4xi())  
                
            
            
            # ---------------------------------------------------------------------------------------------
            # (15) SET CODE4SOURCE                       
            # ---------------------------------------------------------------------------------------------         
            task4set2kernelws ['CODE4SOURCE'] = None
            print('(Step 15A/700) OF KPU2KERNEL4XI5TEST - TRYING TO SET SOURCE OF TASK FOR KERNEL4KPU  ', time4xi())     
            try: 
                source4kpu = {}
                key2source4kpu = folder2lib4kpu + 'kpu2image4xi5test.py'
                code2source4kpu = {}
                code2source4kpu [1] = '#<profile4xi profile = "11" />\n'
                code2source4kpu [2] = '#<program4xi program = "kpu2image4xi5test.py">\n'
                
                source4kpu [key2source4kpu] = code2source4kpu
                                          
                task4set2kernelws ['CODE4SOURCE'] = source4kpu                                                                                                              
                print('(Step 15B/700) OF KPU2KERNEL4XI5TEST - SET SOURCE OF TASK FOR KERNEL4KPU TO: ', task4set2kernelws ['CODE4SOURCE'])                           
                # 
    
            except:
                print('(Step 15Z/700) OF KPU2KERNEL4XI5TEST *** FAILED TO SET SOURCE OF TASK FOR KERNEL4KPU  ', time4xi()) 
            
            # ---------------------------------------------------------------------------------------------
            # (16) SET SIZE4SOURCE             
            # ---------------------------------------------------------------------------------------------         
            task4set2kernelws ['SIZE4SOURCE'] = 0
            print('(Step 16A/700) OF KPU2KERNEL4XI5TEST - TRYING TO SET SOURCE OF TASK FOR KERNEL4KPU  ', time4xi())     
            try: 
                task4set2kernelws ['SIZE4SOURCE'] = len(source4kpu)                                                                                                              
                print('(Step 16B/700) OF KPU2KERNEL4XI5TEST - SET SIZE OF SOURCE OF TASK FOR KERNEL4KPU TO: ', task4set2kernelws ['SIZE4SOURCE'])                           
                # 
    
            except:
                print('(Step 16Z/700) OF KPU2KERNEL4XI5TEST *** FAILED TO SET SOURCE OF TASK FOR KERNEL4KPU  ', time4xi()) 
                            
                                
            # ---------------------------------------------------------------------------------------------
            # (17) SET KERNEL - FINALLY!                           
            # ---------------------------------------------------------------------------------------------          
            response4set2kernel = {} 
            print('(Step 17F/700) OF KPU2KERNEL4XI5TEST - TRYING TO SET KERNEL: ', set2kernel4kpu)   
            # 
            try:                               
                response4set2kernel = set2kernel4kpu(task4set2kernelws)
                print('(Step 17G/700) OF KPU2KERNEL4XI5TEST - SET KERNEL : ', set2kernel4kpu)                                                                                                           
            except:
                print('(Step 17Z/700) OF KPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL ', set2kernel4kpu)  
            try:                                                                                          
                keys2kernel = response4set2kernel.keys()
                for key2kernel in keys2kernel:
                    print('key2kernel ', key2kernel)
                    #              
            except:
                print('(Step 3Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4set2kernel : ', response4set2kernel)                                               

        
        print('FOCUS 15')   
        if KB4Focus['release2kernel4kpu'] == 'NACK4XI': 
            # ---------------------------------------------------------------------------------------------
            # (18) REFERENCE COUNT FOR PROCESSING UNIT RELEASED BY DECREMENTING COUNT WITH 1             
            # ---------------------------------------------------------------------------------------------    
            task4release2kernel  = {} 
            task4release2kernel  ['COUNT2REFERENCE'] = 1 
            response4release2kernel = {}
            
            print('(Step 18A/700) OF KPU2KERNEL4XI5TEST - TRYING TO RELEASE KERNEL OF KPU DEVICE ', time4xi())    
            # 
            try:                               
                response4release2kernel = release2kernel4kpu(task4release2kernel)
                print('(Step 18B/700) OF KPU2KERNEL4XI5TEST - RELEASED KERNEL OF KPU DEVICE ', time4xi()) 
            except:
                print('(Step 18Z1/700) OF KPU2KERNEL4XI5TEST *** FAILED TO RELEASE KERNEL OF KPU DEVICE ', time4xi())                                                                                                  
            try:
                print('(Step 18C/700) OF KPU2KERNEL4XI5TEST COUNT2REFERENCE: ', response4release2kernel ['COUNT2REFERENCE'])
                # 
            except:
                print('(Step 18Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT RESPONSE4RELEASE2KERNEL ', response4release2kernel)  
            
        
            print('(Step 18D/700) OF KPU2KERNEL4XI5TEST - TRYING TO GET COUNT2REFERENCE OF KPU DEVICE ', time4xi())     
            #
            task4getinfo2program = {}
            task4getinfo2program ['COUNT2REFERENCE'] = 'Yes' 
            try:                               
                response4getinfo2program = get2kernelinfo4kpu (task4getinfo2program)
                print('(Step 18E/700) OF KPU2KERNEL4XI5TEST - GOT COUNT2REFERENCE OF KPU DEVICE ', time4xi())
            except:
                print('(Step 18Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO GET SELECTED KERNEL INFO OF KPU DEVICE ', time4xi())
            try:                                                                                                      
                print('(Step 18F/700) OF KPU2KERNEL4XI5TEST - COUNT2REFERENCE: ', response4getinfo2program['COUNT2REFERENCE'] )
                # 
            except:
                print('(Step 18Z3/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT RESPONSE4GETINFO2KERNEL', response4getinfo2program)  

        
        print('FOCUS 16')
        if KB4Focus['retain2kernel4kpu'] == 'NACK4XI':                                                                                                                                                                    
            task4retain2kernel  = {} 
            task4retain2kernel  ['COUNT2REFERENCE'] = 1 
            response4retain2kernel = {}
            
            print('(Step 19A/700) OF KPU2KERNEL4XI5TEST - TRYING TO RETAIN KERNEL OF KPU DEVICE ', time4xi())    
            # 
            try:                               
                response4retain2kernel = retain2kernel4kpu(task4retain2kernel)
                print('(Step 19B/700) OF KPU2KERNEL4XI5TEST - RETAINED KERNEL OF KPU DEVICE ', time4xi()) 
            except:
                print('(Step 19Z1/700) OF KPU2KERNEL4XI5TEST *** FAILED TO RETAIN KERNEL OF KPU DEVICE ', time4xi())                                                                                                  
            try:
                print('(Step 19C/700) OF KPU2KERNEL4XI5TEST COUNT2REFERENCE: ', response4retain2kernel ['COUNT2REFERENCE'])
                # 2
            except:
                print('(Step 19Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT RESPONSE4RETAIN2KERNEL ', response4retain2kernel)  
            
        
            print('(Step 19D/700) OF KPU2KERNEL4XI5TEST - TRYING TO GET COUNT2REFERENCE OF KPU DEVICE ', time4xi())     
            #
            task4getinfo2program = {}
            task4getinfo2program ['COUNT2REFERENCE'] = 'Yes' 
            try:                               
                response4getinfo2program = get2kernelinfo4kpu (task4getinfo2program)
                print('(Step 19E/700) OF KPU2KERNEL4XI5TEST - GOT COUNT2REFERENCE OF KPU DEVICE ', time4xi())
            except:
                print('(Step 19Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO GET SELECTED KERNEL INFO OF KPU DEVICE ', time4xi())
            try:                                                                                                      
                print('(Step 19F/700) OF KPU2KERNEL4XI5TEST - COUNT2REFERENCE: ', response4getinfo2program['COUNT2REFERENCE'] )
                # 2
            except:
                print('(Step 19Z3/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT RESPONSE4GETINFO2KERNEL', response4getinfo2program)  

                    
        print('FOCUS 17')        
        if KB4Focus['set2kernelcallback4kpu'] == 'NACK4XI': 
            # ---------------------------------------------------------------------------------------------
            # (20) SET KERNEL CALLBACKS            
            # ---------------------------------------------------------------------------------------------    
            
            print('(Step 20A/700) OF KPU2KERNEL4XI5TEST - TRYING TO SET KERNEL CALLBACK OF KPU ', time4xi())     
            # 
            try:                               
                response4setcallback2kernel = set2kernelcallback4kpu()                                                                                                 
                print('(Step 20B/700) OF KPU2KERNEL4XI5TEST - SET KERNEL CALLBACK OF KPU TO: ', response4setcallback2kernel)   
                # 
            except:
                print('(Step 20Z1/700) OF KPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL CALLBACK OF KPU ', time4xi())  

        
        print('FOCUS 18')       
        if KB4Focus['trace2kernel4kpu'] == 'NACK4XI':                                                                                                       
            # ---------------------------------------------------------------------------------------------
            # PHASE I: TRACE FUNCTION TESTS                    
            # ---------------------------------------------------------------------------------------------    
            print('(Step 98A/25) OF KPU2KERNEL4XI5TEST - TRYING TO TRACE KPU: ', time4xi())      
            trace2kpu = None
            try:
                trace2kpu = trace2kernel4kpu() 
                print('(Step 98B/25) OF KPU2KERNEL4XI5TEST - TRACE2KPU: ', trace2kpu)  
                # 
        
            except:
                print('(Step 98Z1/25) OF KPU2KERNEL4XI5TEST *** FAILED TO TRACE KPU: ', trace2kpu)     
        
            
        print('FOCUS 19')      
        if KB4Focus['execute2task4kpu'] == 'NACK4XI': 
            print('(Step 99A/700) OF KPU2KERNEL4XI5TEST - TRYING TO EXECUTE TASK OF KPU DEVICE ', time4xi())                                                                                                            
            task4execute2task  = {}
            try:                               
                response4execute2task = execute2task4kpu()
                print('(Step 99B/700) OF KPU2KERNEL4XI5TEST - EXECUTED TASK OF KPU DEVICE ', time4xi())
            except:
                print('(Step 99Z1/700) OF KPU2KERNEL4XI5TEST *** FAILED TO EXECUTE TASK OF KPU DEVICE ', time4xi())  
            try:                                                                                                                 
                keys2response = response4execute2task.keys()
                for key2response in sorted(keys2response):
                    print(key2response, ' : ', response4execute2task[key2response])
                    # 
                    
            except:
                print('(Step 99Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4execute2task ', response4execute2task)      

 
        print('FOCUS 20')      
        if KB4Focus['execute2kernel4kpu'] == 'NACK4XI': 
            print('(Step 99A2/700) OF KPU2KERNEL4XI5TEST - TRYING TO EXECUTE TASK OF KPU DEVICE ', time4xi())                                                                                                            
            kernel4execute2kernel  = {}
            try:                               
                response4execute2kernel = execute2kernel4kpu()
                print('(Step 99B2/700) OF KPU2KERNEL4XI5TEST - EXECUTED TASK OF KPU DEVICE ', time4xi())
            except:
                print('(Step 99Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO EXECUTE TASK OF KPU DEVICE ', time4xi())  
            try:                                                                                                                 
                keys2response = response4execute2kernel.keys()
                for key2response in sorted(keys2response):
                    print(key2response, ' : ', response4execute2kernel[key2response])
                    # 
                    
            except:
                print('(Step 99Z4/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4execute2kernel ', response4execute2kernel) 
                   

        print('FOCUS 21')
        if KB4Focus['create2kernelsinprogram4kpu'] == 'NACK4XI':              
            # ---------------------------------------------------------------------------------------------
            # PHASE I: FUNCTION TESTS - CREATE KERNEL USING FUNCTION                          
            # ---------------------------------------------------------------------------------------------    
            print('(Step 21A2/700) OF KPU2KERNEL4XI5TEST - TRYING TO CREATE KERNELS IN PROGRAM FOR KPU USING FUNCTION ', time4xi())       
            try:
                response4create2kernelsinprogram = create2kernelsinprogram4kpu()
                print('(Step 21B2/700) OF KPU2KERNEL4XI5TEST - CREATED KERNELS IN PROGRAM FOR KPU USING FUNCTION  ', time4xi())
            except:
                print('(Step 21Z1/700) OF KPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNELS IN PROGRAM FOR KPU USING FUNCTION ', time4xi())
            try:                                                                                      
                keys2kernel = response4create2kernelsinprogram.keys()
                for key2kernel in keys2source:
                    print('key2kernel ', key2kernel)
   
            except:
                print('(Step 21Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernelsinprogram ', response4create2kernelsinprogram)

                                                                                 
        # ========================================================================================================================
        # CLASS TESTS
        # ========================================================================================================================    
        
     
        if KB4Focus['KPU2Kernel4Xi'] == 'NACK4XI':
            print('FOCUS 110')                                                                                                                                                                 
            # ---------------------------------------------------------------------------------------------
            # PHASE II: CLASS TESTS                          
            # ---------------------------------------------------------------------------------------------
                     
            print('(Step 110/700) OF KPU2KERNEL4XI5TEST - STARTING CLASS TESTS', time4xi())        
            #       
            tailor2trace4kernel(t2xi)                  # <-- tailor trace again - target functions of activated processes might have reset trace ! 
            
            print('(Step 110A/700) OF KPU2KERNEL4XI5TEST - CREATING KERNEL4KPU OBJECT ', time4xi())        
            try:
                # ---------------------------------------------------------------------------------------------
                # CREATE OBJECT                  
                # ---------------------------------------------------------------------------------------------        
                kernelobject2kpu = KPU2Kernel4Xi()
                print('(Step 110B/700) OF KPU2KERNEL4XI5TEST - CREATED KERNEL4KPU OBJECT: ', kernelobject2kpu)                                  
                # <kpu2kernel4xi.KPU2Kernel4Xi object at 0x000000000424A6D8>
                
            except:
                print('(Step 110Z/700) OF KPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL4KPU OBJECT')
            
            
            print('FOCUS 115')          
            print('(Step 115A/700) OF KPU2KERNEL4XI5TEST - CREATING KERNEL WITH METHOD FOR KPU ', time4xi())        
            try:
                # ---------------------------------------------------------------------------------------------
                # CREATE OBJECT                  
                # ---------------------------------------------------------------------------------------------        
                response2create4kernel = kernelobject2kpu.create2kernel()
                keys2response4create = response2create4kernel.keys()
                print('(Step 115B/700) OF KPU2KERNEL4XI5TEST - CREATED KERNEL WITH METHOD FOR KPU: ', keys2response4create)                                  
                # 
                
            except:
                print('(Step 110Z/700) OF KPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL WITH METHOD FOR KPU')                

            print('FOCUS 121A')      
            if KB4Focus['execute2nativekernel'] == 'NACK4XI':                                                                                                                                  
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - EXECUTE KERNEL FOR KPU                         
                # ---------------------------------------------------------------------------------------------
                print('(Step 121A1/700) OF KPU2KERNEL4XI5TEST - TRY TO EXECUTE KERNEL FOR KPU ', time4xi())      
                try:
                    # ---------------------------------------------------------------------------------------------
                    # EXECUTE                        
                    # ---------------------------------------------------------------------------------------------        
                    response4excute = kernelobject2kpu.execute2nativekernel()
                    print('(Step 121A2/700) OF KPU2KERNEL4XI5TEST - EXECUTED KERNEL FOR KPU ', time4xi())                                   
                except:
                    print('(Step 121AZ1/700) OF KPU2KERNEL4XI5TEST *** FAILED TO EXECUTE KERNEL FOR KPU', time4xi()) 
                try:
                    keys2response4excute = response4excute.keys()
                    for key2response4excute in keys2response4excute:
                        print('(Step 121A3/700) OF KPU2KERNEL4XI5TEST - KEY OF RESPONSE4EXECUTE: ', key2response4excute)
                        # 
                except:
                    print('(Step 121AZ2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT RESPONSE4EXECUTE:' , response4excute)
                             
                tailor2trace4kernel(t2xi) # <-- tailor trace again - target functions of activated processes might have reset trace ! 

            
            print('FOCUS 121C')                                                                                                                                                           
            if KB4Focus['get2kernelworkgroupinfo'] == 'NACK4XI':
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - GET KERNEL WORKGROUPINFO FOR KPU                       
                # ---------------------------------------------------------------------------------------------
                print('(Step 121C1/700) OF KPU2KERNEL4XI5TEST - TRYING TO GET KERNEL WORKGROUPINFO FOR KPU ', time4xi())      
                try:
                    # ---------------------------------------------------------------------------------------------
                    # LINK                        
                    # ---------------------------------------------------------------------------------------------        
                    response4get2workgroupinfo = kernelobject2kpu.get2kernelworkgroupinfo()
                    print('(Step 121C2/700) OF KPU2KERNEL4XI5TEST - GOT KERNEL WORKGROUPINFO FOR KPU ', time4xi())                                   
                except:
                    print('(Step 121CZ1/700) OF KPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL WORKGROUPINFO FOR KPU ', time4xi())  
                try:
                    keys2response4get2workgroupinfo = response4get2workgroupinfo.keys()
                    for key2response4get2workgroupinfo in keys2response4get2workgroupinfo:
                        print('KEY2RESPONSE4GET2WORKGROUPINFO ', key2response4get2workgroupinfo)
                        # 
                except:
                    print('(Step 121CZ2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4get2workgroupinfo ' , response4get2workgroupinfo)

                
            print('FOCUS 122')                      
            if KB4Focus['add2kernel'] == 'NACK4XI':        
                # ---------------------------------------------------------------------------------------------
                # PHASE I: CLASS TESTS - ADD KERNEL INTO KERNEL OBJECT WITH METHOD                          
                # ---------------------------------------------------------------------------------------------    
                print('(Step 122A/700) OF KPU2KERNEL4XI5TEST - TRYING TO ADD KERNEL INTO KERNEL OBJECT WITH METHOD ', time4xi())          
                try:
                    task4add2kernel = {}
                    # 
                    task4add2kernel ['CODE4KERNEL'] = {}
                    task4add2kernel ['SIZE4KERNEL'] = {}
                                
                    task4add2kernel ['CODE4KERNEL'] [folder2lib4kpu + 'kpu2buffer4xi.py'] = {}
                    task4add2kernel ['CODE4KERNEL'] [folder2lib4kpu + 'kpu2buffer4xi.py'] [1] = '#<profile4xi profile = "33" />\n'
                    task4add2kernel ['CODE4KERNEL'] [folder2lib4kpu + 'kpu2buffer4xi.py'] [2] = '#<program4xi program = "kpu2buffer4xi.py" />\n'
                    task4add2kernel ['SIZE4KERNEL'] [folder2lib4kpu + 'kpu2buffer4xi.py'] = len(task4add2kernel ['CODE4KERNEL'] [folder2lib4kpu + 'kpu2buffer4xi.py'])
                    # 
                    task4add2kernel ['CODE4KERNEL'] [folder2lib4kpu + 'kpu2sampler4xi5test.py'] = {}
                    task4add2kernel ['CODE4KERNEL'] [folder2lib4kpu + 'kpu2sampler4xi5test.py'] [1] = '#<profile4xi profile = "33" />\n'
                    task4add2kernel ['CODE4KERNEL'] [folder2lib4kpu + 'kpu2sampler4xi5test.py'] [2] = '#<program4xi program = "kpu2sampler4xi5test.py" />\n'
                    
                    task4add2kernel ['SIZE4KERNEL'] [folder2lib4kpu + 'kpu2sampler4xi5test.py'] = len(task4add2kernel ['CODE4KERNEL'] [folder2lib4kpu + 'kpu2sampler4xi5test.py'])            
                    task4add2kernel ['SIZE4KERNEL'] [folder2lib4kpu + 'kpu2buffer4xi.py'] = len(task4add2kernel ['CODE4KERNEL'] [folder2lib4kpu + 'kpu2buffer4xi.py'])            
                    
                    response4add2kernel = kernelobject2kpu.add2kernel(task4add2kernel)
                    print('(Step 122B/700) OF KPU2KERNEL4XI5TEST - ADDED KERNEL INTO KERNEL OBJECT WITH METHOD ', time4xi())    
                except:
                    print('(Step 122Z1/700) OF KPU2KERNEL4XI5TEST *** FAILED TO ADD KERNEL INTO KERNEL OBJECT WITH METHOD *** ', time4xi())
                try:                                                                                      
                    keys2kernel = response4add2kernel.keys()
                    for keykernel in keys2kernel:
                         print('KEYKERNEL ', keykernel)
                    #                               
                except:
                    print('(Step 1222Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4add2kernel: ', response4add2kernel)  

                
            print('FOCUS 124')          
            if KB4Focus['delete2kernel'] == 'NACK4XI':    
                # ---------------------------------------------------------------------------------------------
                # PHASE I: CLASS TESTS - DELETE KERNEL FROM KERNEL OBJECT WITH CLASS                          
                # ---------------------------------------------------------------------------------------------    
                print('(Step 124A/700) OF KPU2KERNEL4XI5TEST - TRYING TO DELETE KERNEL IN KERNEL OBJECT WITH CLASS ', time4xi())        
                try:
                    task4delete2kernel = {}
                    task4delete2kernel ['CODE4KERNEL'] = {}
                    task4delete2kernel ['CODE4KERNEL'] [folder2lib4kpu + 'kpu2buffer4xi.py'] = 'Yes'
                    task4delete2kernel ['CODE4KERNEL'] [folder2lib4kpu + 'kpu2dummy4xi.py'] = 'Yes'
        
                    task4delete2kernel ['SIZE4KERNEL'] = {}
                    task4delete2kernel ['SIZE4KERNEL'] [folder2lib4kpu + 'kpu2buffer4xi.py'] = 'Yes'
                    task4delete2kernel ['SIZE4KERNEL'] [folder2lib4kpu + 'kpu2dummy4xi.py'] = 'Yes'
                    
                    response4delete2kernel = kernelobject2kpu.delete2kernel(task4delete2kernel)
                    print('(Step 124B/700) OF KPU2KERNEL4XI5TEST - DELETED KERNEL IN KERNEL OBJECT WITH CLASS ', time4xi())
                except:
                    print('(Step 124Z1/700) OF KPU2KERNEL4XI5TEST *** FAILED TO DELETE KERNEL IN KERNEL OBJECT WITH CLASS *** ', time4xi())    
                try:                                                                                      
                    keys2kernel = response4delete2kernel.keys()
                    for key2kernel in keys2kernel:
                        print('KEY2KERNEL ', key2kernel)
                    # 
                                           
                except:
                    print('(Step 124Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4delete2kernel *** ', response4delete2kernel)                    


            
            print('FOCUS 132')         
            if KB4Focus['add2kernel'] == 'NACK4XI':       
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - ADD KERNEL INTO KERNEL OBJECT WITH METHOD                          
                # ---------------------------------------------------------------------------------------------    
                print('(Step 132A/700) OF KPU2KERNEL4XI5TEST - TRYING TO ADD KERNEL INTO KERNEL OBJECT WITH METHOD ', time4xi())         
                try:
                    task4add2kernel = {}
                    task4add2kernel ['CODE4KERNEL'] = {} 
                    task4add2kernel ['CODE4KERNEL'] [folder2lib4kpu + 'kpu3image4xi.py'] [1] = '#<profile4xi profile = "12" />' 
                    task4add2kernel ['CODE4KERNEL'] [folder2lib4kpu + 'kpu3image4xi.py'] [2] = '#<program4xi program = "kpu2dummy4xi.py">'
                    task4add2kernel ['SIZE4KERNEL'] [folder2lib4kpu + 'kpu3image4xi.py'] = len(task4add2kernel ['CODE4KERNEL'] [folder2lib4kpu + 'kpu2dummy4xi.py'])
                    
                    response4add2kernel = kernelobject2kpu.add2kernel(task4add2kernel) 
                    print('(Step 132B/700) OF KPU2KERNEL4XI5TEST - ADDED KERNEL INTO KERNEL OBJECT WITH METHOD ', time4xi())
                except:
                    print('(Step 132Z1/700) OF KPU2KERNEL4XI5TEST *** FAILED TO ADD KERNEL INTO KERNEL OBJECT WITH METHOD *** ', time4xi())
                try:                                                                                          
                    keys2kernel = response4add2kernel['CODE4KERNEL'].keys()
                    for key2kernel in keys2kernel:
                        print('KEY2KERNEL: ', key2kernel)
                    #   
                except:
                    print('(Step 132Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT RESPONSE4ADD2KERNELWITHKERNEL : ', response4add2kernel) 

           
            print('FOCUS 134')              
            if KB4Focus['delete2kernel'] == 'NACK4XI':     
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - DELETE BINARY INSIDE KERNEL OBJECT WITH METHOD                          
                # ---------------------------------------------------------------------------------------------    
                print('(Step 134A/700) OF KPU2KERNEL4XI5TEST - TRYING TO DELETE BINARY INSIDE KERNEL OBJECT WITH METHOD ', time4xi())        
                try:
                    task4delete2kernel = {}
                    task4delete2kernel ['CODE4BINARY'] = {}
                    task4delete2kernel ['CODE4BINARY'] [folder2lib4kpu + '__pycache__//kpu3image4xi.cpython-33.pyc'] = 'Yes'
                    task4delete2kernel ['CODE4BINARY'] [folder2lib4kpu + '__pycache__//dummy3image4xi.cpython-33.pyc'] = 'Yes'
        
                    task4delete2kernel ['SIZE4BINARY'] = {}
                    task4delete2kernel ['SIZE4BINARY'] [folder2lib4kpu + '__pycache__//kpu3image4xi.cpython-33.pyc'] = 'Yes'
                    task4delete2kernel ['SIZE4BINARY'] [folder2lib4kpu + '__pycache__//dummy3image4xi.cpython-33.pyc'] = 'Yes'
                    
                    response4delete2kernel = kernelobject2kpu.delete2kernel(task4delete2kernel)
                    print('(Step 134B/700) OF KPU2KERNEL4XI5TEST - DELETED BINARY INSIDE KERNEL OBJECT WITH METHOD ', time4xi()) 
                                                                                     
                except:
                    print('(Step 134Z1/700) OF KPU2KERNEL4XI5TEST *** FAILED TO DELETE BINARY INSIDE KERNEL OBJECT WITH METHOD *** ', time4xi())
                try:                                                                                          
                    keys2kernel = response4delete2kernel.keys()
                    for key2kernel in keys2kernel:
                        print('KEY2KERNEL ', key2kernel)
                    # 
                except:
                    print('(Step 134Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4delete2kernel : ', response4delete2kernel)   

            
            print('FOCUS 140')                          
            if KB4Focus['get2kernelinfo'] == 'NACK4XI':                 
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - GET METHOD                  
                # ---------------------------------------------------------------------------------------------          

                response4getinfo2kernel = {}
                print('(Step 140A/700) OF KPU2KERNEL4XI5TEST - TRYING TO GET KERNEL INFO OF KPU DEVICE ', time4xi())    
                # 
                try:                               
                    response4getinfo2kernel = kernelobject2kpu.get2kernelinfo(task4getinfo2kernel)
                    print('(Step 140B/700) OF KPU2KERNEL4XI5TEST - GOT KERNEL INFO OF KPU DEVICE ', time4xi()) 
                except:
                    print('(Step 140Z1/700) OF KPU2KERNEL4XI5TEST *** FAILED TO KERNEL INFO OF KPU DEVICE ', time4xi()) 
                try:    
                    keys2kernel = response4getinfo2kernel.keys()
                    for key2kernel in keys2kernel:
                        print('KEY2KERNEL' , key2kernel)
                        #                
                except:
                    pass 
                    #                                    

                
            print('FOCUS 150')                        
            if KB4Focus['set2kernel'] == 'NACK4XI':
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - SET METHOD            
                # ---------------------------------------------------------------------------------------------    
                print('(Step 150A/700) OF KPU2KERNEL4XI5TEST - TRYING TO SET KERNEL ', time4xi())
                    
                # ---------------------------------------------------------------------------------------------
                # (4) INITIALIZE TASK DICTIONARY                         
                # ---------------------------------------------------------------------------------------------            
                task4set2kernel = {}
            
            
                # ---------------------------------------------------------------------------------------------
                # (5) DEFINE CONTEXT - REQUIRED                           
                # ---------------------------------------------------------------------------------------------         
            
                task4set2kernel  ['CONTEXT'] = create2context4kpu()  
            
                
                # ---------------------------------------------------------------------------------------------
                # (6) DEFINE DEVICE - EXTRA                           
                # ---------------------------------------------------------------------------------------------         
            
                task4set2kernel  ['DEVICE'] = init2kpu4xi()  
                                  
            
                # ---------------------------------------------------------------------------------------------
                # (7) DEFINE ERROR CODE - REQUIRED                            
                # ---------------------------------------------------------------------------------------------         
                task4set2kernel  ['CODE2ERROR'] = 0 
            
                
                # ---------------------------------------------------------------------------------------------
                # (8) QUEUE - EXTRA                            
                # ---------------------------------------------------------------------------------------------         
                print('(Step 152A/700) OF KPU2KERNEL4XI5TEST - TRYING TO SET QUEUE4XI ', time4xi()) 
                task4set2kernel  ['QUEUE'] = None
                try:
                    task4set2kernel  ['QUEUE'] = Queue4Xi() 
                    print('(Step 152B/700) OF KPU2KERNEL4XI5TEST - QUEUE : ', task4set2kernel  ['QUEUE']) 
                    # <queue4xi.Queue4Xi object at 0x0000000003D91E10>
                    
                except:
                    print('(Step 152Z1/700) OF KPU2KERNEL4XI5TEST *** FAILED TO CREATE QUEUE4XI ', time4xi()) 
                        
                # ---------------------------------------------------------------------------------------------
                # (9) PIPE                           
                # ---------------------------------------------------------------------------------------------         
                print('(Step 154A/700) OF KPU2KERNEL4XI5TEST - TRYING TO SET PIPE4XI ', time4xi()) 
                task4set2kernel  ['PIPE'] = None
                try:
                    task4set2kernel  ['PIPE'] = Pipe4Xi() 
                    print('(Step 154B/700) OF KPU2KERNEL4XI5TEST - PIPE : ', task4set2kernel  ['PIPE'])
                    # (<read-write PipeConnection, handle 548>, <read-write PipeConnection, handle 552>)
                    
                except:
                    print('(Step 154Z/700) OF KPU2KERNEL4XI5TEST *** FAILED TO SET PIPE4XI ', time4xi()) 
                
                # ---------------------------------------------------------------------------------------------
                # (10) SET COMMAND QUEUE - EXTRA                            
                # ---------------------------------------------------------------------------------------------         
                task4set2kernel ['COMMANDQUEUE'] = None
                print('(Step 156A/700) OF KPU2KERNEL4XI5TEST - TRYING TO SET COMMAND QUEUEFOR KERNEL4KPU ', time4xi())   
                try:                               
                    task4set2kernel ['COMMANDQUEUE'] = create2commandqueue4kpu()                                                                                                                    
                    print('(Step 156B/700) OF KPU2KERNEL4XI5TEST - COMMAND QUEUE OF KERNEL4KPU: ', task4set2kernel ['COMMANDQUEUE'])                           
                    # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
                    
                    
                except:
                    print('(Step 156Z/700) OF KPU2KERNEL4XI5TEST *** FAILED TO SET COMMAND QUEUE FOR KERNEL4KPU ', time4xi())
                      
                # ---------------------------------------------------------------------------------------------
                # (11) SET SOURCE LANGUAGE                           
                # ---------------------------------------------------------------------------------------------         
                
                print('(Step 158A/700) OF KPU2KERNEL4XI5TEST - TRYING TO SET LANGUAGE FOR KERNEL4KPU ', time4xi())   
                try:                               
                    task4set2kernel ['LANGUAGE4SOURCE'] = 'C99'                                                                                                                  
                    print('(Step 158B/700) OF KPU2KERNEL4XI5TEST - LANGUAGE OF KERNEL4KPU: ', task4set2kernel ['LANGUAGE4SOURCE'])                           
                    # C99
                    
                    
                except:
                    print('(Step 158Z/700) OF KPU2KERNEL4XI5TEST *** FAILED TO SET LANGUAGE FOR KERNEL4KPU ', time4xi())  
                    
                        
                # ---------------------------------------------------------------------------------------------
                # (12) SET COUNT4SOURCE              
                # ---------------------------------------------------------------------------------------------         
                print('(Step 12A/700) OF KPU2KERNEL4XI5TEST - TRYING TO SET COUNT4SOURCE FOR KERNEL4KPU ', time4xi())    
                try:                               
                    task4set2kernel ['COUNT4SOURCE'] = int(len(kb2fetch4kpu)/2)                                                                                                               
                    print('(Step 12B/700) OF KPU2KERNEL4XI5TEST - COUNT4SOURCE OF KERNEL4KPU: ', task4set2kernel ['COUNT4SOURCE'])                           
                    # 1
                    
                except:
                    print('(Step 12Z/700) OF KPU2KERNEL4XI5TEST *** FAILED TO SET COUNT4SOURCE FOR KERNEL4KPU ', time4xi())  
                    
                
                # ---------------------------------------------------------------------------------------------
                # (14) SET DIRECTORY4SOURCE                       
                # ---------------------------------------------------------------------------------------------         
                print('(Step 14A/700) OF KPU2KERNEL4XI5TEST - TRYING TO SET DIRECTORY4SOURCE FOR KERNEL4KPU ', time4xi())    
                try: 
                         
                    task4set2kernel ['DIRECTORY4SOURCE'] = folder2lib4kpu                                                                                                          
                    print('(Step 14B/700) OF KPU2KERNEL4XI5TEST - DIRECTORY4SOURCE OF KERNEL4KPU: ', task4set2kernel ['DIRECTORY4SOURCE'])                            
                    # folder2lib4kpu
                    
                except:
                    print('(Step 14Z/700) OF KPU2KERNEL4XI5TEST *** FAILED TO SET DIRECTORY4SOURCE FOR KERNEL4KPU ', time4xi())  
                        
                
                # ---------------------------------------------------------------------------------------------
                # (16) SET LANGUAGE4SOURCE                       
                # ---------------------------------------------------------------------------------------------         
                task4set2kernel ['LANGUAGE4SOURCE'] = None
                print('(Step 16A/700) OF KPU2KERNEL4XI5TEST - TRYING TO SET LANGUAGE4SOURCE FOR KERNEL4KPU ', time4xi())    
                try:                               
                    task4set2kernel ['LANGUAGE4SOURCE'] = "Python"                                                                                                                   
                    print('(Step 16B/700) OF KPU2KERNEL4XI5TEST - LANGUAGE4SOURCE OF KERNEL4KPU: ', task4set2kernel ['LANGUAGE4SOURCE'])                           
                    # Python
                    
                except:
                    print('(Step 16Z/700) OF KPU2KERNEL4XI5TEST *** FAILED TO SET LANGUAGE4SOURCE FOR KERNEL4KPU ', time4xi())  
                    
                
                
                # ---------------------------------------------------------------------------------------------
                # (18) SET CODE4SOURCE                       
                # ---------------------------------------------------------------------------------------------         
                task4set2kernel ['CODE4SOURCE'] = None
                print('(Step 18A/700) OF KPU2KERNEL4XI5TEST - TRYING TO SET SOURCE OF TASK FOR KERNEL4KPU  ', time4xi())     
                try: 
                    source4kpu = {}
                    key2source4kpu = folder2lib4kpu + 'kpu2image4xi5test.py'
                    code2source4kpu = {}
                    code2source4kpu [1] = '#<profile4xi profile = "11" />\n'
                    code2source4kpu [2] = '#<program4xi program = "kpu2image4xi5test.py">\n'
                    
                    source4kpu [key2source4kpu] = code2source4kpu
                                              
                    task4set2kernel ['CODE4SOURCE'] = source4kpu                                                                                                              
                    print('(Step 18B/700) OF KPU2KERNEL4XI5TEST - SET SOURCE OF TASK FOR KERNEL4KPU TO: ', task4set2kernel ['CODE4SOURCE'])                           
                    # {folder2lib4kpu + 'kpu2image4xi5test.py': {1: '#<profile4xi profile = "11" />\n', 2: '#<program4xi program = "kpu2image4xi5test.py">\n'}}
        
                except:
                    print('(Step 18Z/700) OF KPU2KERNEL4XI5TEST *** FAILED TO SET SOURCE OF TASK FOR KERNEL4KPU  ', time4xi()) 
                
                # ---------------------------------------------------------------------------------------------
                # (19) SET SIZE4SOURCE             
                # ---------------------------------------------------------------------------------------------         
                task4set2kernel ['SIZE4SOURCE'] = 0
                print('(Step 19A/700) OF KPU2KERNEL4XI5TEST - TRYING TO SET SOURCE OF TASK FOR KERNEL4KPU  ', time4xi())     
                try: 
                    task4set2kernel ['SIZE4SOURCE'] = len(source4kpu)                                                                                                              
                    print('(Step 19B/700) OF KPU2KERNEL4XI5TEST - SET SIZE OF SOURCE OF TASK FOR KERNEL4KPU TO: ', task4set2kernel ['SIZE4SOURCE'])                           
                    # 
        
                except:
                    print('(Step 19Z/700) OF KPU2KERNEL4XI5TEST *** FAILED TO SET SOURCE OF TASK FOR KERNEL4KPU  ', time4xi()) 
                                                                                 
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - SET KERNEL WITH METHOD FINALLY!                  
                # ---------------------------------------------------------------------------------------------     
                print('(Step 158A/700) OF KPU2KERNEL4XI5TEST - TRYING TO SET KERNEL FOR KPU: ', time4xi())      
                try: 
                    response4set2kernel = kernelobject2kpu.set2kernel(task4set2kernel)
                    print('(Step 158B/700) OF KPU2KERNEL4XI5TEST - SET KERNEL FOR KPU: ', time4xi())    
                except:
                    print('(Step 158Z1/700) OF KPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL FOR KPU: ', time4xi())
                try:                                                                                          
                    keys2response = response4set2kernel.keys()
                    for key2response in keys2response:
                        print('KEY2RESPONSE: ', key2response)

                except:
                    print('(Step 158Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4set2kernel : ', response4set2kernel)  

                 
                
            print('FOCUS 170')                     
            if KB4Focus['release2kernel'] == 'NACK4XI':                                                                              
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - RELEASE KERNEL                           
                # ---------------------------------------------------------------------------------------------    
                print('(Step 170A/700) OF KPU2KERNEL4XI5TEST - RELEASING KERNEL', time4xi())  
                task4release2kernel  = {}
                task4release2kernel  ['COUNT2REFERENCE'] = 1
                try:
                    response4release2kernel = kernelobject2kpu.release2kernel(task4release2kernel)
                    print('(Step 170B/700) OF KPU2KERNEL4XI5TEST - RELEASED KERNEL', time4xi())
                except:
                    print('(Step 170Z1/700) OF KPU2KERNEL4XI5TEST *** FAILED TO RELEASE KERNEL', time4xi())                        
                    keys2response = response4release2kernel.keys()
                try:
                    print('(Step 170C/700) OF KPU2KERNEL4XI5TEST - COUNT2REFERENCE: ', response4release2kernel['COUNT2REFERENCE'] )
                    # 
                except:
                    print('(Step 170Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT RESPONSE4RELEASE2KERNEL', response4release2kernel)  

            
            print('FOCUS 180')                 
            if KB4Focus['retain2kernel'] == 'NACK4XI':                                                                               
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - RETAIN KERNEL                           
                # ---------------------------------------------------------------------------------------------    
                print('(Step 180A/700) OF KPU2KERNEL4XI5TEST - RETAINING KERNEL ', time4xi())
                task4retain2kernel  = {}
                task4retain2kernel  ['COUNT2REFERENCE'] = 1
                try:
                    response4retain2kernel = kernelobject2kpu.retain2kernel(task4retain2kernel)
                    print('(Step 180B/700) OF KPU2KERNEL4XI5TEST - RETAINED KERNEL ', time4xi())
                except:
                    print('(Step 180Z1/700) OF KPU2KERNEL4XI5TEST *** FAILED TO RETAIN KERNEL ', time4xi())                    
                try:
                    print('(Step 180C/700) OF KPU2KERNEL4XI5TEST COUNT2REFERENCE: ', response4retain2kernel ['COUNT2REFERENCE'])
                    # 
                except:
                    print('(Step 180Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT RESPONSE4RETAIN2KERNEL ', response4retain2kernel)

            
            print('FOCUS 190')         
            if KB4Focus['create2kernel'] == 'NACK4XI':               
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - CREATE AGAIN KERNEL OBJECT AND USE ITS CREATE METHOD                           
                # ---------------------------------------------------------------------------------------------        
                print('(Step 190A/700) OF KPU2KERNEL4XI5TEST - TRYING TO CREATE KERNEL FOR KPU ', time4xi()) 
                try:
                    kernelobject2kpu = KPU2Kernel4Xi()                            
                    response4create2kernel = kernelobject2kpu.create2kernel()
                    print('(Step 190B/700) OF KPU2KERNEL4XI5TEST - CREATED KERNEL FOR KPU ', time4xi())
                except:
                    print('(Step 190Z1/700) OF KPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL FOR KPU ', time4xi())                                    
                try:                                                                                      
                    keys2response = response4create2kernel.keys()
                    for key2response in keys2response:
                        print('response' , key2response)
                        
                    #             
                except:
                    print('(Step 190Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT response4create2kernel *** ', response4create2kernel)          

            print('FOCUS 200')         
            if KB4Focus['set2kernelcallback'] == 'NACK4XI':               
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - SET KERNEL CALLBACK WITH METHOD                           
                # ---------------------------------------------------------------------------------------------        
                print('(Step 200A/700) OF KPU2KERNEL4XI5TEST - TRYING TO SET KERNEL CALLBACK WITH METHOD OF OBJECT XI2KPU: ', kernelobject2kpu) 
                try:
                    callback2kpu = kernelobject2kpu.set2kernelcallback()                                  
                    print('(Step 200B/700) OF KPU2KERNEL4XI5TEST - SET KERNEL WITH CALLBACK TO: ', callback2kpu)
                    # 
                except:
                    print('(Step 200Z/700) OF KPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL CALLBACK WITH METHOD ***', time4xi())                  

                            
            print('FOCUS 210')         
            if KB4Focus['trace2kernel'] == 'NACK4XI':                                                                                                      
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - TRACE KERNELS                           
                # ---------------------------------------------------------------------------------------------    
                print('(Step 210A/25) OF KPU2KERNEL4XI5TEST - TRYING TO TRACE KPU: ', time4xi())      
                trace2kpu = None
                try:
                    trace2kpu = kernelobject2kpu.trace2kernel() 
       
                    print('(Step 210B/25) OF KPU2KERNEL4XI5TEST - TRACE2KPU: ', trace2kpu)  
                    # {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4kpu-failed {}; time: 04:40:24 11/16/11 Pacific Standard Time}', 'CLASS': 'trace2kernel4kpu', 'METHOD': 'trace2kernel4kpu'}

                except:
                    print('(Step 210Z1/25) OF KPU2KERNEL4XI5TEST *** FAILED TO TRACE KPU: ', trace2kpu)     

                                                                                                                               
            print('FOCUS 220')
            if KB4Focus['release2kernel'] == 'NACK4XI':
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - RELEASE KERNEL BY DECREMENTING REFERENCE COUNT WITH 1             
                # ---------------------------------------------------------------------------------------------    
                task4release2kernel  = {} 
                task4release2kernel  ['COUNT2REFERENCE'] = 1 
                response4release2kernel = {}
               
                print('(Step 220A/700) OF KPU2KERNEL4XI5TEST - TRYING TO RELEASE KERNEL OF KPU DEVICE ', time4xi())    
                # 
                try:                               
                    response4release2kernel = kernelobject2kpu.release2kernel(task4release2kernel)                                                                                             
                    print('(Step 220B/700) OF KPU2KERNEL4XI5TEST - RELEASED KERNEL OF KPU DEVICE ', time4xi())
                except:
                    print('(Step 220Z1/700) OF KPU2KERNEL4XI5TEST *** FAILED TO RELEASE KERNEL OF KPU DEVICE ', time4xi())
                try:                           
                    keys2response = response4release2kernel.keys()
                    for key2response in sorted(keys2response):
                        print(key2response, ' : ', response4release2kernel[key2response])
                        # 
                except:
                    print('(Step 220Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT RESPONSE4RELEASE2KERNEL ', response4release2kernel)  
                
                task4getinfo2kernel = {}
                task4getinfo2kernel ['COUNT2REFERENCE'] = 0
                response4getinfo2kernel = {}
                print('(Step 220C/700) OF KPU2KERNEL4XI5TEST - TRYING TO GET SELECTED KERNEL INFO OF KPU DEVICE ', time4xi())     
                # 
                try:                               
                    response4getinfo2kernel = kernelobject2kpu.get2kernelinfo (task4getinfo2kernel)
                    print('(Step 220D/700) OF KPU2KERNEL4XI5TEST - GOT SELECTED KERNEL INFO OF KPU DEVICE ', time4xi()) 
                except:
                    print('(Step 220Z4/700) OF KPU2KERNEL4XI5TEST *** FAILED TO GET SELECTED KERNEL INFO OF KPU DEVICE ', time4xi())
                try:                                                                                                        
                    keys2response = response4getinfo2kernel.keys()
                    for key2response in sorted(keys2response):
                        print(key2response, ' : ', response4getinfo2kernel[key2response])
                        # 
                except:
                    print('(Step 220Z5/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT RESPONSE4GETINFO2KERNEL ', response4getinfo2kernel)  

                
            print('FOCUS 230')                                         
            if KB4Focus['retain2kernel'] == 'NACK4XI':   
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - RETAIN KERNEL BY DECREASING REFERENCE WITH 1             
                # ---------------------------------------------------------------------------------------------    
                task4retain2kernel  = {}
                task4retain2kernel  ['COUNT2REFERENCE'] = 1 
                response4retain2kernel = {}
                print('(Step 230A/700) OF KPU2KERNEL4XI5TEST - TRYING TO RETAIN KERNEL OF KPU DEVICE ', time4xi())   
                try:                               
                    response4retain2kernel = kernelobject2kpu.retain2kernel(task4retain2kernel)                                                                                                 
                    print('(Step 230B/700) OF KPU2KERNEL4XI5TEST - RETAINED KERNEL OF KPU DEVICE ', time4xi()) 
                except:
                    print('(Step 230Z1/700) OF KPU2KERNEL4XI5TEST *** FAILED TO RETAIN KERNEL OF KPU DEVICE ', time4xi())
                try:                                       
                    keys2response = response4retain2kernel.keys()
                    for key2response in sorted(keys2response):
                        print(key2response, ' : ', response4retain2kernel[key2response])
                        # 
                except:
                    print('(Step 230Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT RESPONSE4RETAIN2KERNEL ', response4retain2kernel)
                    
                task4getinfo2kernel = {}
                task4getinfo2kernel ['COUNT2REFERENCE'] = 0
                response4getinfo2kernel = {}
                print('(Step 230C/700) OF KPU2KERNEL4XI5TEST - TRYING TO GET SELECTED KERNEL INFO OF KPU DEVICE ', time4xi())     
                # 
                try:                               
                    response4getinfo2kernel = kernelobject2kpu.get2kernelinfo (task4getinfo2kernel)
                    print('(Step 230D/700) OF KPU2KERNEL4XI5TEST - GOT SELECTED KERNEL INFO OF KPU DEVICE ', time4xi())
                except:
                    print('(Step 230Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO GET SELECTED KERNEL INFO OF KPU DEVICE ', time4xi())                                                                                                   
                try:
                    keys2response = response4getinfo2kernel.keys()
              
                    for key2response in sorted(keys2response):
                        print(key2response, ' : ', response4getinfo2kernel[key2response])
                        # 
                except:
                    print('(Step 230Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT RESPONSE4GETINFO2KERNEL ', response4getinfo2kernel)         

            print('FOCUS 240')         
            if KB4Focus['execute2task'] == 'NACK4XI':
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - EXECUTE KERNEL                           
                # ---------------------------------------------------------------------------------------------                                                   
                task4execute2task  = {}
                print('(Step 240A/700) OF KPU2KERNEL4XI5TEST - TRYING TO EXECUTE KERNEL OF KPU DEVICE ', time4xi())    
                try:                               
                    response4execute2task = kernelobject2kpu.execute2task(task4execute2task) 
                    print('(Step 240B/700) OF KPU2KERNEL4XI5TEST - BUILT KERNEL OF KPU DEVICE ', time4xi())
                except:
                    print('(Step 240Z1/700) OF KPU2KERNEL4XI5TEST *** FAILED TO EXECUTE KERNEL OF KPU DEVICE ', time4xi())
                try:                                                                                                     
                    keys2response = response4execute2task.keys()
                    for key2response in sorted(keys2response):
                        print(key2response, ' : ', response4execute2task[key2response])
                #                
                except:
                    print('(Step 240Z2/700) OF KPU2KERNEL4XI5TEST *** FAILED TO PRINT ', response4execute2task)            

            
            print('FOCUS 310')         
            if KB4Focus['sense'] == 'NACK4XI':
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - SENSE KERNEL                           
                # ---------------------------------------------------------------------------------------------    
                print('(Step 310A/700) OF KPU2KERNEL4XI5TEST - SENSING ', time4xi())  
                try:
                    print(kernelobject2kpu.sense())
                    print('(Step 310B/700) OF KPU2KERNEL4XI5TEST - SENSED ', time4xi()) 
                    # {'object': <kpu2kernel4xi.KPU2Kernel4Xi object at 0x0000000003E00AC8>, 'classvariable2kpu-of-KPU2Kernel4Xi': 4}
                except:
                    print('(Step 310Z/700) OF KPU2KERNEL4XI5TEST *** FAILED TO SENSE ', time4xi())          

            
            print('FOCUS 320')          
            if KB4Focus['reason'] == 'NACK4XI':    
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - REASON KERNEL                           
                # ---------------------------------------------------------------------------------------------    
                print('(Step 320A/700) OF KPU2KERNEL4XI5TEST - REASONING ', time4xi())
                try:
                    print(kernelobject2kpu.reason())
                    print('(Step 320B/700) OF KPU2KERNEL4XI5TEST - REASONED ', time4xi())
                    # KPU2Kernel4Xi-reasoned-by-reason-of-KPU2Kernel4Xi: <class 'kpu2kernel4xi.KPU2Kernel4Xi'>; time: 04:40:25 11/16/11 Pacific Standard Time}
                except:
                    print('(Step 320Z/700) OF KPU2KERNEL4XI5TEST *** FAILED TO REASON ', time4xi()) 

            
            print('FOCUS 330')                                                    
            if KB4Focus['ace'] == 'NACK4XI':         
                # ---------------------------------------------------------------------------------------------
                # PHASE II: CLASS TESTS - ACE KERNEL                           
                # ---------------------------------------------------------------------------------------------    
                print('(Step 330A/700) OF KPU2KERNEL4XI5TEST - ACING ', time4xi())   
                try:
                    print(kernelobject2kpu.ace())
                    print('(Step 330B/700) OF KPU2KERNEL4XI5TEST - ACED ', time4xi())                                                 
                    # {'object-reason-object4xi': <kpu2kernel4xi.KPU2Kernel4Xi object at 0x0000000003E00AC8>, 'time-reason-of-KPU2Kernel4Xi': '04:40:25 11/16/11 Pacific Standard Time'}
                except:
                    print('(Step 330Z/700) OF KPU2KERNEL4XI5TEST *** FAILED TO ACE ', time4xi())

                                                                    
        else:
            pass                                                                                                    # CLASS NOT IN FOCUS 
             
        # ---------------------------------------------------------------------------------------------
        # DONE - ALL TESTS                          
        # ---------------------------------------------------------------------------------------------    
        print('(Step 700/700) OF KPU2KERNEL4XI5TEST - DONE! ', time4xi())
    except:
        print('(Step 175/700) OF KPU2KERNEL4XI5TEST *** FAILED ****  ', time4xi())
    finally:            
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print2trace4xi(t2xi)        
           
      
#</function4xi>            
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main function for kpu2kernel4xi5test
#"> 

# -------------------------------------------------------------------------------------------------    
def main():
    print("(Step 0A/700) OF KPU2KERNEL4XI5TEST - SENSING IT WITH YOURKPUXI!", time4xi())   

    kpu2kernel4xi5test()  

    print("(Step 0B/700) OF KPU2KERNEL4XI5TEST - SENSED IT WITH YOURKPUXI!", time4xi()) 
    # 
                          
#</function4xi>
     

# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#</program4xi>
 
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# kpu2kernel4xi5test.txt
# sense-kpu2kernel4xi5test.xml
# reason-kpu2kernel4xi5test.xml
# ace-kpu2kernel4xi5test.xml
#" 
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>

# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# nothing
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>


#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of kpu2kernel4xi5test.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/> 
